indexing

   title:       "Container for the picture formatters";
   cluster:     "format/commerce [format/commerce]";
   project:     "The Universal Simple Formatting Library (USFL)";
   copyright:   "SIG Computer, 1995";
   author:      "Andy Malakov  (andy@eiffel.ru) and";
   original:    08,Sep,1995;
   version:     1.0;
   last_change: 14,Sep,1995;
   done_at:     "SIG Computer (info@eiffel.ru)";
   extrnl_name: "fmt_tb_p.e"

class PICTURE_FORMAT_TABLE [ G -> PICTURE_FORMATTER ]

   inherit
      FORMAT_TABLE [ G ]
         end

   creation make

   feature

      ----------------------------------------------------------------
      search_by_patchar ( patchar : CHARACTER ) is
         local
            tools : STRING_TOOLS
            i : INTEGER
         do
            !!tools
            from
               found_index := lower; found := false
            until
               found or else found_index > upper
            loop
               if tools.contain (item(found_index).pattern, patchar) then
                  found := true
                  found_item := item ( found_index )
               else
                  found_index := found_index + 1
               end
            end -- loop
         end -- search_by_patchar
      ----------------------------------------------------------------
      search_by_picture ( picture : STRING ) is
            -- Search object mostly confirm to picture
         require
            Void_picture : picture /= Void
         local
            i, max_ndx : INTEGER
         do
            from
               i := 1; found := true
            until
               not found or else i > picture.count
            loop
               search_by_patchar ( picture @ i )
               if found then
                  if found_index > max_ndx then
                     max_ndx := found_index
                  end
               end
               i := i + 1
            end -- loop i

            if found then
               found_index := max_ndx
               found_item := item ( found_index )
            end
         end -- search_by_picture

end -- class PICTURE_FORMAT_TABLE
