indexing

   title:       "Unsigned number formatter for any base";
   cluster:     "format/science [format/science]";
   project:     "The Universal Simple Formatting Library (USFL)";
   copyright:   "SIG Computer, 1995";
   author:      "Igor Nesterof (nest@eiffel.ru)";
   original:    08,Sep,1995;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   extrnl_name: "uns_fmt.e"

class UNSIGNED_INTEGER_FORMATTER

inherit
    ABSTRACT_JUSTIFY_FORMATTER
    redefine
        make, set_align_char
    end

creation
    make, make_with_base

feature {ABSTRACT_FORMATTER}

   align_char : CHARACTER
   inum : INTEGER
   base : INTEGER

feature

------------------------------------------------------------make
   make, frozen unsigned_make (i:INTEGER_REF) is
   require else
      format_number : i /= Void
      positive_argument : i >=0
   do
      make_with_base(i,10)
   end

------------------------------------------------------------make_with_base
   make_with_base(i:INTEGER_REF, b : INTEGER) is
   require
      base_is_legal : b>1 and then b<37
   do
      abstract_justify_make(i)
      align_char := ' '
      inum := i.item
      base := b
   end

feature {ABSTRACT_FORMATTER}
------------------------------------------------------------set_align_char
    set_align_char(c : CHARACTER) is
    require else
        legal_align_char : (c = ' ') or else (c = '0')
    do
        align_char := c
    end
------------------------------------------------------------digits string
    digits : STRING is "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"
------------------------------------------------------------get_plain_number_image
    get_plain_number_image(i:INTEGER):STRING is
    local
        s : STRING
        n : INTEGER
    do
        from
            s := ""
            n := i
        until
            n = 0
        loop
            s.precede(digits.item((n\\base)+1))
            n := n // base
        end
        if (i=0) then
            Result := "0"
        else
            Result := s
        end
    end

------------------------------------------------------------output
   output:STRING is
   local
      str : STRING
   do
      if (prec=0) and then (inum=0) then
         Result := ""
      else
         str := left_pad(get_plain_number_image(inum),'0',prec)
         inspect alignment
         when align_left then
            Result := right_pad(str,align_char,width)
         when align_right then
            Result := left_pad(str,align_char,width)
         when align_center then
            Result := center_pad(str,align_char,width)
         end
      end
   end

end --class UNSIGNED_INTEGER_FORMATTER
